#ifndef _MATCHERS_H
#define _MATCHERS_H

#include <vector>
#include <set>
/* Matchters */
#include "PatMatch.h"
#include "BitmapFont.h"

class MatchResult {
  friend ostream& operator<<(ostream &os,const MatchResult &mr);
 protected:
  int x,y;
  PatMatch pm;
  int penalty;
 public:
  MatchResult(int xx, int yy,const PatMatch& p,int penalty) :x(xx),y(yy),pm(p),penalty(penalty){}
  std::vector<pixel> getPixels() const;
};

class Matchers {
  friend ostream& operator<<(ostream &os,const Matchers &mt);
 protected:
  std::vector<PatMatch> pm;
 public:
  Matchers();
  std::vector<MatchResult> findMatch(const BitmapFont& bf) const;
  std::vector<pixel> notCovered(const BitmapFont& bf) const;
};
ostream& operator<<(ostream &os,const Matchers &mt);
ostream& operator<<(ostream &os,const MatchResult &mr);
#endif /* _MATCHERS_H */
